﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Xml.Serialization;
using System.IO;

namespace howto_serialize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Create a Person, serialize it, and display the serialization.
        private void btnSerialize_Click(object sender, EventArgs e)
        {
            // Make a new Person.
            Person per = new Person(
                txtFirstName.Text,
                txtLastName.Text,
                txtStreet.Text,
                txtCity.Text,
                txtState.Text,
                txtZip.Text);

            // Make the XmlSerializer and StringWriter.
            XmlSerializer xml_serializer = new XmlSerializer(typeof(Person));
            using (StringWriter string_writer = new StringWriter())
            {
                // Serialize.
                xml_serializer.Serialize(string_writer, per);

                // Display the serialization.
                txtSerialization.Text = string_writer.ToString();
            }

            // Reset the TextBoxes.
            txtFirstName.Clear();
            txtLastName.Clear();
            txtStreet.Clear();
            txtCity.Clear();
            txtState.Clear();
            txtZip.Clear();
        }

        // Deserialize a Person.
        private void btnDeserialize_Click(object sender, EventArgs e)
        {
            // Deserialize the serialization.
            XmlSerializer xml_serializer = new XmlSerializer(typeof(Person));
            using (StringReader string_reader = new StringReader(txtSerialization.Text))
            {
                Person per = (Person)(xml_serializer.Deserialize(string_reader));

                // Display the Person's properties in the TextBoxes.
                txtFirstName.Text = per.FirstName;
                txtLastName.Text = per.LastName;
                txtStreet.Text = per.Street;
                txtCity.Text = per.City;
                txtState.Text = per.Street;
                txtZip.Text = per.Zip;
            }

            txtSerialization.Clear();
        }
    }
}
